
#pragma hdrstop
#include <condefs.h>

#include <iostream.h>
#include <conio.h>

//fonction de saisie
void getValues(int n, double* t)
{
  //petit message
  cout << "commencer la saisie de " << n << " elements" << endl;

  //saisie
  for (int i=0;i<n;i++)
   cin >> t[i];
}

//trier les valeurs selon la recherche de min successifs
void sortValues(int n, double* t)
{
 double curMin;//minimum courant
 int iMin;//repre
 int i,j;//indice pour parcourir le tableau

 //pour chaque case du tableau
 for (i=0;i<n-1;i++)
 {
   curMin = t[i];
   iMin = i;
   //reprer s'il existe un plus petit que lui dans le reste du tableau
   for (j=i+1;j<n;j++)
   {
     if (t[j]<curMin)
     {
       iMin = j;
       curMin = t[j];
     }
   }
   //effectuer l'change
   t[iMin] = t[i];
   t[i] = curMin;
 }
}

//calculer la mdiane du tableau
double computeMediane(int n,double* t)
{
  //comme on n'est pas assur que l'opration a t ralis avant !
  sortValues(n,t);
  //suite... distinguer le cas pair et impair
  if (n % 2 != 0)
    return t[n/2];
  else
    return 0.5*(t[n/2-1]+t[n/2]);
}

//---------------------------------------------------------------------------
#pragma argsused
int main(int argc, char* argv[])
{
        int n;
        cout << "taille du tableau : ";
        cin >> n;

        double* t = new double[n];

        getValues(n,t);
        double med = computeMediane(n,t);

        cout << "Mediane = " << med;

        getch();

        return 0;
}
